/*
 * cz2cz tools
 * Copyright (C) 2005 Vlastimil Krejcir
 *
 * This file is part of cz2cz.
 *
 * cz2cz is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include"cz2czdef.h"

char *ret_charcod(int code)
{ switch (code) {
  case CZ_ISO: return "ISO-8859-2";
  case CZ_WIN: return "Win-1250";
  case CZ_LAT: return "PCLatin2";
  case CZ_KAM: return "Kamenickych";
  case CZ_UTF8: return "UTF8";
  case CZ_ASCII: return "7-bit ASCII";
  case CZ_POST: return "postfixove sprezky";
  case CZ_PREF: return "prefixove sprezky";
  case CZ_TEX: return "TeX konvence";
  default: return "nedef.";
  }
}

int ret_cod(char *code) /* vraci cislo daneho kodovani */
{ if (strcmp(code, "win") == 0) return CZ_WIN;
  else if (strcmp(code, "utf8") == 0) return CZ_UTF8;
  else if (strcmp(code, "pc2") == 0) return CZ_LAT;
  else if (strcmp(code, "kam") == 0) return CZ_KAM;
  else if (strcmp(code, "iso") == 0) return CZ_ISO;
  else if (strcmp(code, "ascii") == 0) return CZ_ASCII;
  else if (strcmp(code, "post") == 0) return CZ_POST;
  else if (strcmp(code, "pref") == 0) return CZ_PREF;
  else if (strcmp(code, "tex") == 0) return CZ_TEX;
  else return -1;
}

int ret_end(char *line_end)
{ if (strcmp(line_end, "crlf") == 0) return CRLF;
  else if (strcmp(line_end, "lf") == 0) return LF;
  
  return -1;
}

char *ret_charend(int r)
{ if (r == CRLF) return "<CR><LF>";
  else if (r == LF) return "<LF>";
       else if (r == CR) return "<CR>";
            else if (r == CZ_CANTDETTECTLINEENDS) return "nezname konce radku";
	         else return "ponechat zdrojove";
}
