/* conf.c - zpracovani konfiguracniho souboru (program cz2cz) */
/*
 * cz2cz tools
 * Copyright (C) 2004 Vlastimil Krejcir
 *
 * This file is part of cz2cz.
 *
 * cz2cz is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<stdio.h>
#include<string.h>
#include<stdlib.h>

#include"cz2czdef.h" /* definice maker */
#include"errors.h" /* errors.h chybova i jina hlaseni */

unsigned long c_start;
int c_mode;
char str[8], *c_destination_code, *c_source_code, *c_pp, *c_l_ends;

char c_c[2];
char c;

/* pri uspechu vraci 1, jinak 0 */
int conf_file(FILE *fil)
{ /* inicializace */
  c_destination_code=NULL;
  c_source_code=NULL;
  c_pp=NULL;
  c_start=0;
  c_mode=0;
  /* konec inicializace */

  while (fscanf(fil, " %7s", str)  != EOF) {
    
    if (str[0] == '#') { /* zpracovani radku s poznamkou */ 
      while ((c=getc(fil)) != '\n')
        if (c == EOF) return 1;
      continue;
    } 
    if (fscanf(fil, " %1s", c_c) != EOF) {
          
      if (strcmp(c_c, "=") == 0) {

        if (strcmp(str, "zdr_kod") == 0) { /* zdr_kod promenna */
	  if ((c_source_code=((char *) malloc(7))) == NULL) return -2;
	  if (fscanf(fil, " %5s", c_source_code) != EOF) continue;  
	  else
	  {/* neni-li konec souboru */
	    fprintf(stderr, "%s", geterr(CZ_CONFFERR)); /* chybny konfig. soubor */
	    return 0; /* prerus dalsi zpracovani (ukonci while) */
	  }
	}	
        
	if (strcmp(str, "cil_kod") == 0) { /* cil_kod promenna */
	  if ((c_destination_code=((char *) malloc(7))) == NULL) return -2;
	  if (fscanf(fil, " %5s", c_destination_code) != EOF) continue;
	  else
	  { /* neni-li konec souboru */
	    fprintf(stderr, "%s", geterr(CZ_CONFFERR)); /* chybny konfig. soubor */
	    return 0; /* prerus dalsi zpracovani (ukonci while) */
	  }
	}
	
	if (strcmp(str, "k_radku") == 0) { /* cil_kod promenna */
	  if ((c_l_ends=((char *) malloc(5))) == NULL) return -2;
	  if (fscanf(fil, " %4s", c_l_ends) != EOF) continue;
	  else
	  { /* neni-li konec souboru */
	    fprintf(stderr, "%s", geterr(CZ_CONFFERR)); /* chybny konfig. soubor */
	    return 0; /* prerus dalsi zpracovani (ukonci while) */
	  }
	}
          
	if (strcmp(str, "mod") == 0) { /* cil_kod promenna */
	  if (fscanf(fil, " %d", &c_mode) != EOF)  /* neni-li konec souboru */
	     continue;		
	  else { 
	    fprintf(stderr, "%s", geterr(CZ_CONFFERR)); /* chybny konfig. soubor */
	    return 0; /* prerus dalsi zpracovani (ukonci while) */
	  }
        } 

        if (strcmp(str, "start") == 0) { /* start promenna */
	  if (fscanf(fil, " %lu", &c_start) != EOF) continue; /* neni-li konec souboru */
	  else {
	    fprintf(stderr, "%s", geterr(CZ_CONFFERR)); /* chybny konfig. soubor */
	    return 0; /* prerus dalsi zpracovani (ukonci while) */
          }
	}
  
        if (strcmp(str, "pripona") == 0) { /* pripona promenna */
	  if ((c_pp=((char *) malloc(256))) == NULL) return -2; /* vyhrad si pamet pro priponu */
	  if (fscanf(fil, " %s", c_pp) != EOF) continue; /* neni-li konec souboru */
	  else {
	    fprintf(stderr, "%s", geterr(CZ_CONFFERR)); /* chybny konfig. soubor */
	    return 0; /* prerus dalsi zpracovani (ukonci while) */
	  }
	}
	else { 
	  fprintf(stderr, "%s", geterr(CZ_BADVARCONFF)); /* neznama prom. v konfig. soubor */
	  return 0;
	}
	  
      }
      else { /* pokud nenactu znak '=' */
	fprintf(stderr, "%s", geterr(CZ_CONFFERR));
	return 0; /* ukonci zpracovani */
      }    
    }
    else { /* doslo-li ke konci uz pri kontrole znaku '=' */
      fprintf(stderr, "%s", geterr(CZ_CONFFERR));
      return 0; /* ukonci zpracovani */
    }
  } /* konec hlavniho cyklu */  	      
    
  return 1;
}

void c_free(void)
{ 
  free((void *) c_source_code); c_source_code=NULL;
  free((void *) c_destination_code); c_destination_code=NULL;
  free((void *) c_pp); c_pp=NULL;
  free((void *) c_l_ends); c_l_ends=NULL;
}








