/* errors.c - chybova a varovna hlaseni (program cz2cz) */
/*
 * cz2cz tools
 * Copyright (C) 2004 Vlastimil Krejcir
 *
 * This file is part of cz2cz.
 *
 * cz2cz is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<stdio.h>

#include"cz2czdef.h"

char *geterr(int err_n)
{
  switch (err_n) {
/*  case CZ_DEFSUFFIXMEMERR: return "cz2cz: Chyba: Nedostatek pameti pro inicializaci defaultni pripony.\n"; */
    /*  case CZ_TOLONGPATH: return "cz2cz: Chyba: Prilis dlouha cesta k domovskemu adresari (nedostatek pameti).\n"; */
  case CZ_CANTCLOSEF: return "cz2cz: Chyba: Nemohu uzavrit soubor "; /* ukonceni neni */
  case CZ_CANTOPENF: return "cz2cz: Chyba: Nemohu otevrit soubor "; /* ukonceni neni */
    /*
  case CZ_TOLONGSUFFIX: return "cz2cz: Chyba: Prilis dlouha pripona (nedostatek pameti).\n";
  case CZ_TOLONGOUTPUTF: return "cz2cz: Chyba: Prilis dlouhe jmeno vystupniho souboru (nedostatek pameti).\n";
    */
  case CZ_STDOUTERR: return "cz2cz: Chyba: Nepodarilo se zapsat na standardni vystup.\n";
  case CZ_CODENOTSUPP: return "cz2cz: Chyba: Tento prevod neni implementovan.\n";
  case CZ_CANTWRITETOF: return "cz2cz: Chyba: Nepodarilo se zapsat do souboru "; /* neni ukonceni */
  case CZ_NOINPUTF: return "cz2cz: Chyba: Nebyl zadan zadny vstupni soubor.\n";
  case CZ_NOTENOUGHMEM: return "cz2cz: Chyba: Nedostatek pameti.\n";
  case CZ_INPUTFDIRERR: return "cz2cz: Chyba: Vystupni soubor nesmi byt adresarem.\n";
  case CZ_OUTPUTFDIRERR: return "cz2cz: Chyba: Vstupnim souborem nesmi byt adresar.\n";
  case CZ_CANTPREPTEMP: return "cz2cz: Chyba: Nelze pripravit temp soubor.\n";
  case CZ_CANTOPENTEMP: return "cz2cz: Chyba: Nelze otevrit temp soubor pro cteni.\n";
  case CZ_DIRNEEDED: return "cz2cz: Chyba: Parametr volby -o musi byt adresar.\n";
  case CZ_EMPTYSUFFIX: return "cz2cz: Chyba: Pripona nesmi byt prazdna.\n";
  case CZ_DIR: return "cz2cz: Chyba: Adresar "; /*ukonceni neni */
    /*
  case 19: return "cz2cz: Chyba: Neznama chyba pri mazani temp souboru.\n";
    */
  case CZ_INPUTFNEEDED: return "cz2cz: Chyba: Musite vlozit nejaky vstupni soubor.\n";
  case CZ_CANTOPENDB: return "cz2cz: Chyba: Nepodarilo se otevrit databazi.\n";
  case CZ_INPUTCODENEEDED: return "cz2cz: Chyba: Musite vlozit vstupni kodovani.\n";
  case CZ_CANTCREATEDB: return "cz2cz: Chyba: Nemohu vytvorit databazovy soubor.\n";
  case CZ_DETECTFAILED: return "cz2cz: Chyba: Detekce kodovani se nezdarila - je velmi pravdepodobne, ze\n"
                  "text obsahuje pouze pismena, ktera se v ruznych kodovanich zobrazuji stejne.\n";
  case CZ_BADOUTPUTCODE: return "cz2cz: Chyba: Chybne nastavena hodnota vystupniho kodovani.\n";
  case CZ_BADINPUTCODE: return "cz2cz: Chyba: Chybne nastavena hodnota vstupniho kodovani.\n";
  case CZ_BADOUTPUTCODE_CONF: return "cz2cz: Chyba: Chybne nastavena hodnota vystupniho kodovani v konfig. souboru.\n";
  case CZ_BADINPUTCODE_CONF: return "cz2cz: Chyba: Chybne nastavena hodnota vstupniho kodovani v konfig. souboru.\n";
  case CZ_BADLENDS_CONF: return "cz2cz: Chyba: Chybne nastavena hodnota konce radku v konfig. souboru.\n";
  case CZ_BADMODE_CONF: return "cz2cz: Chyba: Chybne nastavena hodnota modu v konfig. souboru.\n";
  case CZ_CONFFERR: return "cz2cz: Chyba: Chyba v konfiguracnim souboru.\n";
  case CZ_BADVARCONFF: return "cz2cz: Chyba: Neznama promenna v konfiguracnim souboru.\n";
  case CZ_BADLINEEND: return "cz2cz: Chyba: Chybne nastaveno ukoncovani radku.\n";
  case CZ_BADMODE: return "cz2cz: Chyba: Chybne vlozeni modu.\n";
  case CZ_CANTSETSUFFIX: return "cz2cz: Chyba: Nelze nastavit -p kvuli chybnemu modu.\n";
  case CZ_SEEKERROR: return "cz2cz: Chyba: Nelze provest presun v souboru";
  default: return "cz2cz: Neznama chyba.\n";
  }
}

void puterr(int err_n, const char *str)
{ switch (err_n) {
  case 1: fprintf(stderr, "cz2cz: Varovani: Detekce kodovani souboru \"%s\" se nezdarila " 
                 "- je velmi pravdepodobne, ze text obsahuje pouze pismena, ktera se v ruznych "
		 "kodovanich zobrazuji stejne.\n", str); break;
  case 2: fprintf(stderr, "cz2cz: Varovani: Detekce kodovani souboru \"%s\" nemusi byt 100%%-tni.\n", str); break;
  case 3: fprintf(stderr, "cz2cz: Chyba: Detekce kodovani souboru \"%s\" se nezdarila " 
                 "- je velmi pravdepodobne, ze text obsahuje pouze pismena, ktera se v ruznych "
		 "kodovanich zobrazuji stejne. Soubor nebude preveden - muzete prevest soubor manualne.\n", str); break;
  default: fprintf(stderr, "cz2cz: Neznama chyba.\n");
  }
}

char *getwar(int war_n)
{  
  switch (war_n) {
  case CZ_CANTUSEOUTPUTF: return "cz2cz: Varovani: Nelze volit vystupni soubor, mod neni roven 0, volba bude\n"
                 "ignorovana.\n";
  case CZ_CANTOPENCONFF: return "cz2cz: Varovani: Nemohu otevrit konfiguracni soubor "; /* neni ukonceni */
  
  case CZ_BADSTARTNO: return "cz2cz: Varovani: Startovni cislo nesmi byt < 0; nastavuji defaultne 0.\n";

  case CZ_SIMPLEDETECT: return "cz2cz: Varovani: Detekce kodovani nemusi byt 100%-tni.\n";
  case CZ_SAMECODES: return "cz2cz: Varovani: Kodovani souboru je stejne jako cilove kodovani.\n";
  case CZ_DBNOTEXIST: return "cz2cz: Varovani: Soubor s databazi nebyl nalezen. Bude vytvoren novy.\n";
  default: return "cz2cz: Nezname varovani\n";
  }
}

				         











