/* tables.c - prevodni cast + tabulky (program cz2cz) */
/*
 * cz2cz tools
 * Copyright (C) 2005 Vlastimil Krejcir
 *
 * This file is part of cz2cz.
 *
 * cz2cz is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<stdio.h>
#include<ctype.h>
#include<string.h>

#include"cz2czdef.h" /* definice maker */

#ifndef isascii
#define isascii(c) (((c) & ~0x7f) == 0)
#endif

typedef int TABLE[128];
typedef char *L_TABLE[128];

FILE *in, *out;
int l; /* ukoncovani radku */
int i;

int read_char(int *c_ch)
{ unsigned char pom_char;
  const char cr=13, lf=10;

  if (fread(&pom_char, sizeof(pom_char), 1, in) != 1) return 0;

  if (l != SAME) { /* pokud je nutno prekodovat konce radku */
  
    while ((pom_char == lf) || (pom_char == cr)) {
      if (pom_char == cr) { if (fread(&pom_char, 1, 1, in) != 1) { *c_ch=pom_char; return 1; } }  
      if (l == LF) { 
        if (fwrite(&lf, sizeof(lf), 1, out) != 1) return 0; 
      }
      else { 
        if (fwrite(&cr, sizeof(cr), 1, out) != 1) return 0;
        if (fwrite(&lf, sizeof(lf), 1, out) != 1) return 0;
      }
      if (fread(&pom_char, sizeof(pom_char), 1, in) != 1) return 0;
    }
  }

  *c_ch=pom_char;
  return 1;
}

int cod2cod(void)
{ unsigned char c;
  int pom_cc;

  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (fwrite(&c, sizeof(c), 1, out) != 1) return 0;
  }
  
  return 1;
}

int iso2win(void)
{ unsigned char c, c_out;
  int pom_cc;
  TABLE tab_iso2win={128, 128, 128, 128, 128, 128, 128, 128, 128, 128,
                     128, 128, 128, 128, 128, 128, 128, 128, 128, 128,
                     128, 128, 128, 128, 128, 128, 128, 128, 128, 128,
                     128, 128, 128, 165, 162, 163, 164, 188, 140, 167,
                     168, 138, 170, 141, 143, 173, 142, 175, 176, 185, 
                     178, 179, 180, 190, 156, 161, 184, 154, 186, 157, 
                     159, 189, 158, 191, 192, 193, 194, 195, 196, 197, 
                     198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 
                     208, 209, 210, 211, 212, 213, 214, 215, 216, 217, 
                     218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 
                     228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 
                     238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 
                     248, 249, 250, 251, 252, 253, 254, 255 };

  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) c_out=c;
    else c_out=tab_iso2win[c-128];
    if (fwrite(&c_out, sizeof(c_out), 1, out) != 1) return 0;
  }

  return 1;
}

int iso2lat(void)
{ unsigned char c, c_out;
  int pom_cc;
  TABLE tab_iso2lat={255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
                     255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 
                     255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
                     255, 255, 255, 164, 244, 157, 207, 149, 151, 245, 
                     249, 230, 184, 155, 141, 248, 166, 189, 255, 165, 
                     242, 139, 239, 150, 152, 243, 247, 231, 173, 156, 
                     171, 241, 167, 190, 232, 181, 182, 198, 142, 145, 
                     143, 128, 172, 144, 168, 211, 183, 214, 215, 210, 
                     209, 227, 213, 224, 226, 138, 153, 158, 252, 222,
                     233, 235, 154, 237, 221, 225, 234, 160, 131, 199, 
                     132, 146, 134, 135, 159, 130, 169, 137, 216, 161, 
                     140, 212, 208, 228, 229, 162, 147, 139, 148, 246, 
                     253, 133, 163, 251, 129, 236, 238, 250};

  while (read_char(&pom_cc)) { 
    c=pom_cc;
    if (isascii(c)) c_out=c;
    else c_out=tab_iso2lat[c-128];
    if (fwrite(&c_out, sizeof(c_out), 1, out) != 1) return 0;
  }

  return 1;
}

int iso2kam(void)
{ unsigned char c, c_out;
  int pom_cc;
  TABLE tab_iso2kam={ 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
                      255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
                      255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
                      255, 255, 255, 65, 94, 76, 111, 156, 83, 173,
                      34, 155, 83, 134, 90, 196, 146, 90, 255, 97,
                      44, 111, 39, 150, 115, 94, 44, 168, 115, 159,
                      122, 34, 145, 122, 171, 143, 65, 65, 142, 138,
                      67, 67, 128, 144, 69, 69, 137, 139, 73, 133,
                      68, 78, 165, 149, 79, 79, 153, 120, 158, 166,
                      151, 85, 154, 157, 84, 225, 170, 160, 97, 97,
                      132, 141, 99, 99, 135, 130, 101, 101, 136, 161,
                      105, 131, 100, 110, 164, 162, 147, 111, 148, 246,
                      169, 150, 163, 117, 129, 152, 116, 39};

  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) c_out=c;
    else c_out=tab_iso2kam[c-128];
    if (fwrite(&c_out, sizeof(c_out), 1, out) != 1) return 0;
  }

  return 1;
}

int iso2ascii(void)
{ unsigned char c, c_out;
  int pom_cc;
  TABLE tab_iso2ascii={ 32, 32, 32, 32, 32, 32, 32, 32, 32, 32,
                        32, 32, 32, 32, 32, 32, 32, 32, 32, 32,
                        32, 32, 32, 32, 32, 32, 32, 32, 32, 32,
                        32, 32, 32, 65, 32, 76, 32, 76, 83, 32,                        
                        32, 83, 83, 84, 90, 32, 90, 90, 32, 97, 
                        32, 108, 32, 108, 115, 32, 32, 115, 115, 116, 
                        122, 32, 122, 122, 82, 65, 65, 65, 65, 76,
                        67, 67, 67, 69, 69, 69, 69, 73, 73, 68,
                        68, 78, 78, 79, 79, 79, 79, 42, 82, 85,
                        85, 85, 85, 89, 84, 115, 114, 97, 97, 97,
                        97, 108, 99, 99, 99, 101, 101, 101, 101, 105,
                        105, 100, 100, 110, 110, 111, 111, 111, 111, 47,
                        114, 117, 117, 117, 117, 121, 116, 32 }; 
   
  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c) == 1) { c_out=c; }
    else { c_out=tab_iso2ascii[c-128];
    }
    if (fwrite(&c_out, sizeof(c_out), 1, out) != 1) return 0;
  }

  return 1;
}

int iso2post(void)
{ unsigned char c;
  int pom_cc;
  L_TABLE tab_iso2post={"", "", "", "", "", "", "", "", "", "",
                        "", "", "", "", "", "", "", "", "", "",
                        "", "", "", "", "", "", "", "", "", "", 
                        "", "", "", "A,", "", "L~", "", "L<", "S'", "[paragraf]",
                        ":", "S<", "S,", "T<", "Z'", "-", "Z<", "Z`", "", "a,",
                        "", "l~", "'", "l<", "s'", "<", ",", "s<", "s,", "t<",
                        "z'", "\"", "z<", "z`", "R'", "A'", "A^", "A", "A:", "L'",
                        "C'", "C,", "C<", "E'", "E,", "E:", "E<", "I'", "I^", "D<",
                        "D~", "N'", "N<", "O'", "O^", "O\"", "O:", "x", "R<", "U*",
                        "U'", "U\"", "U:", "Y'", "T,", "s", "r'", "a'", "a^", "a",
                        "a:", "l'", "c'", "c,", "c<", "e'", "e,", "e:", "e<", "i'", 
                        "i^", "d<", "d~", "n'", "n<", "o'", "o^", "o\"", "o:", "~", 
                        "r<", "u*", "u'", "u\"", "u:", "y'", "t,", ""};

  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) { if (fwrite(&c, sizeof(c), 1, out) != 1) return 0; }
    else {
      if (fwrite(tab_iso2post[c-128], sizeof(c), strlen(tab_iso2post[c-128]), out) 
          != strlen(tab_iso2post[c-128])) return 0;
    }
  }

  return 1;
}

int iso2pref(void)
{ unsigned char c;
  int pom_cc;
  L_TABLE tab_iso2pref={"", "", "", "", "", "", "", "", "", "",
                        "", "", "", "", "", "", "", "", "", "",
                        "", "", "", "", "", "", "", "", "", "", 
                        "", "", "", "A,", "", "~L", "", ">L", "'S", "[paragraf]",
                        ":", ">S", ",S", ">T", "'Z", "-", ">Z", "`Z", "", ",a",
                        "", "~l", "'", ">l", "'s", "<", ",", ">s", ",s", ">t",
                        "'z", "\"", ">z", "`z", "'R", "'A", "^A", "A", ":A", "'L",
                        "'C", ",C", ">C", "'E", ",E", ":E", ">E", "'I", "^I", ">D",
                        "~D", "'N", ">N", "'O", "^O", "\"O", ":O", "x", ">R", "*U",
                        "'U", "\"U", ":U", "'Y", ",T", "s", "'r", "'a", "^a", "a",
                        ":a", "'l", "'c", ",c", ">c", "'e", ",e", ":e", ">e", "'i", 
                        "^i", ">d", "~d", "'n", ">n", "'o", "^o", "\"o", ":o", "~", 
                        ">r", "*u", "'u", "\"u", ":u", "'y", ",t", ""};
  
  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) { if (fwrite(&c, sizeof(c), 1, out) != 1) return 0; }
    else {
      if (fwrite(tab_iso2pref[c-128], sizeof(c), strlen(tab_iso2pref[c-128]), out) 
          != strlen(tab_iso2pref[c-128])) return 0;
    }
  }

  return 1;
}

int iso2tex(void)
{ unsigned char c;
  int pom_cc;
  L_TABLE tab_iso2tex={"", "", "", "", "", "", "", "", "", "",
                        "", "", "", "", "", "", "", "", "", "",
                        "", "", "", "", "", "", "", "", "", "", 
                        "", "", "", "A", "\\u{}", "\\L", "", "\\v{L}", "\\'{S}", "\\S",
                        "", "\\v{S}", "S", "\\v{T}", "\\'{Z}", "-", "\\v{Z}", "\\.{Z}", "", "a",
                        "", "\\l", "\\'", "\\v{l}", "\\'{s}", "\\v{}", "\\c{}", "\\v{s}", "\\c{s}", "\\v{t}",
                        "\\'{z}", "\\H{}", "\\v{z}", "\\.{z}", "\\'{R}", "\\'{A}", "\\^{A}", "\\u{A}", "\\\"{A}", "\\'{L}",
                        "\\'{C}", "\\c{C}", "\\v{C}", "\\'{E}", "E", "\\\"{E}", "\\v{E}", "\\'{I}", "\\^{I}", "\\v{D}",
                        "", "\\'{N}", "\\v{N}", "\\'{O}", "\\^{O}", "\\H{O}", "\\\"{O}", "\\times", "\\v{R}", "\\r{U}",
                        "\\'{U}", "\\H{U}", "\\\"{U}", "\\'{Y}", "\\c{T}", "\\ss", "\\'{r}", "\\'{a}", "\\^{a}", "\\u{a}",
                        "\\\"{a}", "\\'{l}", "\\'{c}", "\\c{c}", "\\v{c}", "\\'{e}", "e", "\\\"{e}", "\\v{e}", "\\'\\i", 
                        "\\^\\i", "\\v{d}", "", "\\'{n}", "\\v{n}", "\\'{o}", "\\^{o}", "\\H{o}", "\\\"{o}", "$\\div$", 
                        "\\v{r}", "\\r{u}", "\\'{u}", "\\H{u}", "\\\"{u}", "\\'{y}", "\\c{t}", "\\.{}"};
  
  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) { if (fwrite(&c, sizeof(c), 1, out) != 1) return 0; }
    else {
      if (fwrite(tab_iso2tex[c-128], sizeof(c), strlen(tab_iso2tex[c-128]), out) 
          != strlen(tab_iso2tex[c-128])) return 0;
    }
  }

  return 1;
}



int win2iso(void)
{ unsigned char c, c_out;
  int pom_cc;
  TABLE tab_win2iso={128, 129, 44, 34, 168, 133, 134, 135, 136, 137,
                     169, 60, 166, 171, 174, 172, 144, 96, 39, 34,
                     34, 255, 45, 45, 152, 153, 185, 62, 182, 187, 
                     190, 188, 160, 183, 162, 163, 164, 161, 160, 167,
                     168, 67, 170, 60, 92, 173, 82, 175, 176, 43,
                     178, 179, 180, 117, 124, 255, 184, 177, 186, 62,
                     165, 189, 181, 191, 192, 193, 194, 195, 196, 197,
                     198, 199, 200, 201, 202, 203, 204, 205, 206, 207,
                     208, 209, 210, 211, 212, 213, 214, 215, 216, 217,
                     218, 219, 220, 221, 222, 223, 224, 225, 226, 227,
                     228, 229, 230, 231, 232, 233, 234, 235, 236, 237,
                     238, 239, 240, 241, 242, 243, 244, 245, 246, 247,
                     248, 249, 250, 251, 252, 253, 254, 255};

  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) c_out=c;
    else c_out=tab_win2iso[c-128];
    if (fwrite(&c_out, sizeof(c_out), 1, out) != 1) return 0;
  }

  return 1;
}

int win2lat(void)
{ unsigned char c, c_out;
  int pom_cc;
  TABLE tab_win2lat={255, 255, 44, 34, 249, 255, 255, 255, 255, 255,
                     230, 60, 151, 155, 166, 141, 255, 96, 39, 34,
                     34, 250, 45, 45, 255, 255, 231, 62, 152, 156,
                     167, 171, 255, 243, 244, 157, 207, 164, 255, 245,
                     249, 67, 184, 174, 92, 248, 82, 189, 255, 43,
                     242, 139, 239, 117, 124, 250, 247, 165, 173, 175,
                     149, 241, 150, 190, 232, 181, 182, 198, 142, 145,
                     143, 128, 172, 144, 168, 211, 183, 214, 215, 210,
                     209, 227, 213, 224, 226, 138, 153, 158, 252, 222,
                     233, 235, 154, 237, 221, 225, 234, 160, 131, 199,
                     132, 146, 134, 135, 159, 130, 169, 137, 216, 161,
                     140, 212, 208, 228, 229, 162, 147, 139, 148, 246,
                     253, 133, 163, 251, 129, 236, 238, 250};

  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) c_out=c;
    else c_out=tab_win2lat[c-128];
    if (fwrite(&c_out, sizeof(c_out), 1, out) != 1) return 0;
  }

  return 1;
}

int win2kam(void)
{ unsigned char c, c_out;
  int pom_cc;
  TABLE tab_win2kam={255, 255, 44, 34, 34, 255, 255, 255, 255, 255,
                     155, 60, 83, 134, 146, 90, 255, 96, 39, 34,
		     34, 39, 45, 45, 255, 255, 168, 62, 115, 159,
		     145, 122, 255, 94, 94, 76, 111, 65, 255, 173,
		     34, 67, 83, 174, 92, 196, 82, 90, 255, 43,
		     44, 111, 39, 117, 124, 39, 44, 97, 115, 175,
		     156, 34, 150, 122, 171, 143, 65, 65, 142, 138,
		     67, 67, 128, 144, 69, 69, 137, 139, 73, 133,
		     68, 78, 165, 149, 79, 79, 153, 120, 158, 166,
		     151, 85, 154, 157, 84, 225, 170, 160, 97, 97,
		     132, 141, 99, 99, 135, 130, 101, 101, 136, 161,
		     105, 131, 100, 110, 164, 162, 147, 111, 148, 246,
		     169, 150, 163, 117, 129, 152, 116, 39}; 
		     
  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) c_out=c;
    else c_out=tab_win2kam[c-128];
    if (fwrite(&c_out, sizeof(c_out), 1, out) != 1) return 0;
  }

  return 1;
}

int win2ascii(void)
{ unsigned char c, c_out;
  int pom_cc;
  TABLE tab_win2ascii={32, 32, 39, 32, 34, 46, 32, 32, 32, 37,
                       83, 60, 83, 84, 90, 90, 32, 96, 39, 34,
		       34, 46, 45, 45, 32, 116, 115, 62, 115, 116,
		       122, 122, 32, 94, 94, 76, 111, 65, 32, 32, 
		       32, 99, 83, 60, 32, 45, 114, 90, 32, 43, 
		       44, 108, 39, 117, 32, 46, 44, 97, 115, 62,
		       76, 34, 108, 122, 82, 65, 65, 65, 65, 76,
                       67, 67, 67, 69, 69, 69, 69, 73, 73, 68,
                       68, 78, 78, 79, 79, 79, 79, 42, 82, 85,
                       85, 85, 85, 89, 84, 115, 114, 97, 97, 97,
                       97, 108, 99, 99, 99, 101, 101, 101, 101, 105,
                       105, 100, 100, 110, 110, 111, 111, 111, 111, 47,
                       114, 117, 117, 117, 117, 121, 116, 32}; 


  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) c_out=c;
    else c_out=tab_win2ascii[c-128];
    if (fwrite(&c_out, sizeof(c_out), 1, out) != 1) return 0;
  }

  return 1;
}

int win2post(void)
{ unsigned char c;
  int pom_cc;
  L_TABLE tab_win2post={"", "", ",", "", "\"", "...", "+", "++", "", "%",
                        "S<", "<", "S'", "T<", "Z<", "Z'", "", "`", "'", "\"",
                        "\"", ".", "-", "-", "", "TM", "s<", ">", "s'", "t<", 
                        "z<", "z'", "", "<", "", "L~", "", "A,", "", "[paragraf]",
                        ":", "(C)", "S,", "<<", "-|", "-", "(R)", "Z`", "", "+-",
                        "", "l~", "'", "[mikro]", "", ".", ",", "a,", "s,", ">>",
                        "L<", "\"", "l<", "z`", "R'", "A'", "A^", "A", "A:", "L'",
                        "C'", "C,", "C<", "E'", "E,", "E:", "E<", "I'", "I^", "D<",
                        "D~", "N'", "N<", "O'", "O^", "O\"", "O:", "x", "R<", "U*",
                        "U'", "U\"", "U:", "Y'", "T,", "s", "r'", "a'", "a^", "a",
                        "a:", "l'", "c'", "c,", "c<", "e'", "e,", "e:", "e<", "i'", 
                        "i^", "d<", "d~", "n'", "n<", "o'", "o^", "o\"", "o:", "~", 
                        "r<", "u*", "u'", "u\"", "u:", "y'", "t,", ""};

  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) { if (fwrite(&c, sizeof(c), 1, out) != 1) return 0; }
    else {
      if (fwrite(tab_win2post[c-128], sizeof(c), strlen(tab_win2post[c-128]), out) 
          != strlen(tab_win2post[c-128])) return 0;
    }
  }

  return 1;
}

int win2pref(void)
{ unsigned char c;
  int pom_cc;
  L_TABLE tab_win2pref={"", "", ",", "", "\"", "...", "+", "++", "", "%",
                        ">S", "<", "'S", ">T", ">Z", "'Z", "", "`", "'", "\"",
                        "\"", ".", "-", "-", "", "TM", ">s", ">", "'s", ">t", 
                        ">z", "'z", "", ">", "", "~L", "", ",A", "", "[paragraf]",
                        ":", "(C)", ",S", "<<", "-|", "-", "(R)", "'Z", "", "+-",
                        "", "~l", "'", "[mikro]", "", ".", ",", "a,", ",s", ">>",
                        ">L", "\"", ">l", "`z", "'R", "'A", "^A", "A", ":A", "'L",
                        "'C", ",C", ">C", "'E", ",E", ":E", ">E", "'I", "^I", ">D",
                        "~D", "'N", ">N", "'O", "^O", "\"O", ":O", "x", ">R", "*U",
                        "'U", "\"U", ":U", "'Y", ",T", "s", "'r", "'a", "^a", "a",
                        ":a", "'l", "'c", ",c", ">c", "'e", ",e", ":e", ">e", "'i", 
                        "^i", ">d", "~d", "'n", ">n", "'o", "^o", "\"o", ":o", "~", 
                        ">r", "*u", "'u", "\"u", ":u", "'y", ",t", ""};
  
  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) { if (fwrite(&c, sizeof(c), 1, out) != 1) return 0; }
    else {
      if (fwrite(tab_win2pref[c-128], sizeof(c), strlen(tab_win2pref[c-128]), out) 
          != strlen(tab_win2pref[c-128])) return 0;
    }
  }

  return 1;
}

int win2tex(void)
{ unsigned char c;
  int pom_cc;
  L_TABLE tab_win2tex={"", "", ",", "", "\\clqq", "\\dots", "\\dag", "\\ddag", "", "\\%",
                       "\\v{S}", "<", "\\'{S}", "\\v{T}", "\\v{Z}", "", "`", "'", "\"", "\"",
                       "$\\bullet$", "-", "--", "", "$^{TM}$", "\\v{s}", ">", "\\'{s}", "\\v{t}", "\\v{z}", 
                       "\\'{z}", "", "\\v{}", "A", "\\u{}", "\\L", "", "A", "", "\\S",
                       "\\\"{}", "\\copyright", "S", "<<", "$\\neq$", "-", "(R)", "\\.{Z}", "", "$\\pm$",
                       "", "\\l", "\\'", "$\\mu$", "\\P", "\\.{}", "\\c{}", "s", "\\c{s}", ">>",
                       "\\v{L}", "\\H{}", "\\v{l}", "\\.{z}", "\\'{R}", "\\'{A}", "\\^{A}", "\\u{A}", "\\\"{A}", "\\'{L}",
                       "\\'{C}", "\\c{C}", "\\v{C}", "\\'{E}", "\\k{E}", "\\\"{E}", "\\v{E}", "\\'{I}", "\\^{I}", "\\v{D}",
                       "", "\\'{N}", "\\v{N}", "\\'{O}", "\\^{O}", "\\H{O}", "\\\"{O}", "\\times", "\\v{R}", "\\r{U}",
                       "\\'{U}", "\\H{U}", "\\\"{U}", "\\'{Y}", "\\c{T}", "\\ss", "\\'{r}", "\\'{a}", "\\^{a}", "\\u{a}",
                       "\\\"{a}", "\\'{l}", "\\'{c}", "\\c{c}", "\\v{c}", "\\'{e}", "\\k{e}", "\\\"{e}", "\\v{e}", "\\'\\i", 
                       "\\^\\i", "\\v{d}", "", "\\'{n}", "\\v{n}", "\\'{o}", "\\^{o}", "\\H{o}", "\\\"{o}", "$\\div$", 
                       "\\v{r}", "\\r{u}", "\\'{u}", "\\H{u}", "\\\"{u}", "\\'{y}", "\\c{t}", "\\.{}"};
  
  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) { if (fwrite(&c, sizeof(c), 1, out) != 1) return 0; }
    else {
      if (fwrite(tab_win2tex[c-128], sizeof(c), strlen(tab_win2tex[c-128]), out) 
          != strlen(tab_win2tex[c-128])) return 0;
    }
  }

  return 1;
}



int lat2iso(void)
{ unsigned char c, c_out;
  int pom_cc;
  TABLE tab_lat2iso={199, 252, 233, 226, 228, 249, 230, 231, 235, 213,
                     179, 245, 238, 172, 196, 198, 201, 197, 229, 244,
		     246, 165, 181, 166, 182, 214, 220, 171, 187, 163,
		     215, 232, 225, 237, 243, 250, 161, 177, 174, 190,
		     202, 234, 128, 188, 200, 186, 60, 62, 32, 32,
		     39, 124, 43, 193, 194, 204, 170, 43, 124, 43,
                     43, 175, 191, 43, 43, 43, 43, 43, 45, 43,
		     195, 227, 43, 43, 43, 43, 43, 43, 43, 164,
		     240, 208, 207, 203, 239, 210, 205, 206, 236, 43,
		     43, 32, 32, 222, 217, 32, 211, 223, 212, 209,
		     241, 242, 169, 185, 192, 218, 224, 219, 253, 221,
		     254, 180, 32, 189, 178, 183, 162, 167, 247, 184,
		     32, 168, 255, 251, 216, 248, 32, 128}; 

  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) c_out=c;
    else c_out=tab_lat2iso[c-128];
    if (fwrite(&c_out, sizeof(c_out), 1, out) != 1) return 0;
  }

  return 1;
}

int lat2win(void)
{ unsigned char c, c_out;
  int pom_cc;
  TABLE tab_lat2win={199, 252, 233, 226, 228, 249, 230, 231, 235, 213,
                     179, 245, 238, 143, 196, 198, 201, 197, 229, 244,
		     246, 188, 190, 140, 156, 214, 220, 141, 157, 163,
                     215, 232, 225, 237, 243, 250, 165, 185, 142, 158,
		     202, 234, 128, 159, 200, 186, 171, 187, 32, 32,
		     39, 124, 43, 193, 194, 204, 170, 43, 124, 43,
		     43, 175, 191, 43, 43, 43, 43, 43, 45, 43,
		     195, 227, 43, 43, 43, 43, 43, 43, 43, 164,
		     240, 208, 207, 203, 239, 210, 205, 206, 236, 43,
		     43, 32, 32, 222, 217, 32, 211, 223, 212, 209,
		     241, 242, 138, 154, 192, 218, 224, 219, 253, 221,
		     254, 180, 32, 189, 178, 161, 162, 167, 247, 184,
		     32, 168, 255, 251, 216, 248, 32, 128}; 

  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) c_out=c;
    else c_out=tab_lat2win[c-128];
    if (fwrite(&c_out, sizeof(c_out), 1, out) != 1) return 0;
  }

  return 1;
}

int lat2kam(void)
{ unsigned char c, c_out;
  int pom_cc;
  TABLE tab_lat2kam={67, 129, 130, 97, 132, 150, 99, 99, 108, 101, 
                     79, 111, 105, 90, 142, 67, 144, 138, 141, 147,
                     148, 156, 150, 83, 115, 153, 154, 134, 159, 76,
                     120, 135, 160, 161, 162, 163, 65, 97, 146, 145,
                     69, 101, 255, 122, 128, 115, 174, 175, 176, 177,
                     178, 179, 180, 143, 65, 137, 83, 185, 186, 187,
                      188, 90, 122, 191, 192, 193, 194, 195, 196, 197,
                     65, 97, 200, 201, 202, 203, 204, 205, 206, 111,
                     100, 68, 133, 69, 131, 165, 139, 73, 136, 217, 
                     218, 219, 220, 84, 166, 223, 149, 225, 79, 78, 
                     110, 164, 155, 168, 171, 151, 170, 85, 152, 157,
                     116, 39, 196, 34, 44, 94, 94, 173, 246, 44,
                     196, 34, 39, 117, 158, 169, 254, 255}; 

  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) c_out=c;
    else c_out=tab_lat2kam[c-128];
    if (fwrite(&c_out, sizeof(c_out), 1, out) != 1) return 0;
  }

  return 1;

}

int lat2ascii(void)
{ unsigned char c, c_out;
  int pom_cc;
  TABLE tab_lat2ascii={67, 117, 101, 97, 97, 117, 99, 99, 108, 101,
                       79, 111, 105, 90, 65, 67, 69, 76, 108, 111,
                       111, 76, 108, 83, 115, 79, 85, 84, 116, 76,
                       120, 99, 97, 105, 11, 117, 65, 97, 90, 122,
                       69, 101, 127, 122,  67, 115, 60, 62, 32, 32,
                       32, 124, 43, 65, 65, 69, 83, 43, 124, 43,
                       43, 90, 122, 43, 43, 43, 43, 43, 45, 43,
                       65, 97, 43, 43, 43, 43, 43, 45, 43, 111,
                       100, 68, 68, 69, 100, 78, 73, 73, 101, 43,
                       43, 32, 32, 84, 85, 32, 79, 115, 79, 78,
                       110, 110, 83, 115, 122, 85, 114, 85, 121, 89,
                       74, 39, 32, 34, 44, 32, 32, 32, 47, 44,
                       32, 32, 32, 117, 82, 114, 32, 117}; 

  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) c_out=c;
    else c_out=tab_lat2ascii[c-128];
    if (fwrite(&c_out, sizeof(c_out), 1, out) != 1) return 0;
  }

  return 1;
}

int lat2post(void)
{ unsigned char c;
  int pom_cc;
  L_TABLE tab_lat2post={"C,", "u:", "e'", "a^", "a:", "u*", "c'", "c,", "l~", "e:",
                        "O\"", "o\"", "i^", "Z'", "A:", "C'", "E'", "L'", "l'", "o^",
                        "o:", "L<", "l<", "S'", "s'", "O:", "U:", "T<", "t<", "L~", 
                        "x", "c<", "a'", "i'", "o'", "u'", "A,", "a,", "Z<", "z<",
                        "E,", "e,", "", "z'", "C<", "s,", "<<", ">>", " ", " ",
                        " ", "|", "+", "A'", "A^", "E<", "S,", "+", "|", "+",
                        "+", "Z`", "z`", "+", "+", "+", "+", "+", "-", "+",
                        "A", "a", "+", "+", "+", "+", "+", "-", "+", "o",
			"d~", "D~", "D<", "E:", "d<", "N<", "I'", "I^", "e<", "+",
                        "+", " ", " ", "T,", "U*", " ", "O'", "s", "O^", "N'", 
                        "n'", "n<", "S<", "s<", "R'", "U'", "r'", "U\"", "y'", "Y'",
                        "t,", "'", " ", "\"", ",", "<", " ", "[paragraf]", "/", ",", 
                        "-", ":", "`", "u\"", "R<", "r<", " ", ""};

   
  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) { if (fwrite(&c, sizeof(c), 1, out) != 1) return 0; }
    else {
      if (fwrite(tab_lat2post[c-128], sizeof(c), strlen(tab_lat2post[c-128]), out) 
          != strlen(tab_lat2post[c-128])) return 0;
    }
  }

  return 1;
}

int lat2pref(void)
{ unsigned char c;
  int pom_cc;
  L_TABLE tab_lat2pref={",C", ":u", "'e", "^a", ":a", "*u", "'c", ",c", "~l", ":e",
                        "\"O", "\"o", "^i", "'Z", ":A", "'C", "'E", "'L", "'l", "^o",
                        ":o", ">L", ">l", "'S", "'s", ":O", ":U", ">T", ">t", "~L", 
                        "x", ">c", "'a", "'i", "'o", "'u", ",A", ",a", ">Z", ">z",
                        ",E", ",e", "", "'z", ">C", ",s", "<<", ">>", " ", " ",
                        " ", "|", "+", "'A", "^A", ">E", ",S", "+", "|", "+",
                        "+", "`Z", "`z", "+", "+", "+", "+", "+", "-", "+",
                        "A", "a", "+", "+", "+", "+", "+", "-", "+", "o",
			"~d", "~D", ">D", ":E", ">d", ">N", "'I", "^I", ">e", "+",
                        "+", " ", " ", ",T", "*U", " ", "'O", "s", "^O", "'N", 
                        "'n", ">n", ">S", ">s", "'R", "'U", "'r", "\"U", "'y", "'Y",
                        ",t", "'", " ", "\"", ",", "<", " ", "[paragraf]", "/", ",", 
                        "-", ":", "`", "\"u", ">R", ">r", " ", ""};

   
  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) { if (fwrite(&c, sizeof(c), 1, out) != 1) return 0; }
    else {
      if (fwrite(tab_lat2pref[c-128], sizeof(c), strlen(tab_lat2pref[c-128]), out) 
          != strlen(tab_lat2pref[c-128])) return 0;
    }
  }

  return 1;
}



int lat2tex(void)
{ unsigned char c;
  int pom_cc;
  L_TABLE tab_lat2tex={"\\c{C}", "\\\"{u}", "\\'{e}", "\\^{a}", "\\\"{a}", "\\r{u}", "\\'{c}", "\\c{c}", "\\l", "\\\"{e}",
                        "\\H{O}", "\\H{o}", "\\^\\i", "\\'{Z}", "\\\"{A}", "\\'{C}", "\\'{E}", "\\'{L}", "\\'{l}", "\\^{o}",
                        "\\\"{o}", "\\v{L}", "\\v{l}", "\\'{S}", "\\'{s}", "\\\"{O}", "\\\"{U}", "\\v{T}", "\\v{t}", "\\L", 
                        "$\times$", "\\v{c}", "\\'{a}", "\\'\\i", "\\'{o}", "\\'{u}", "A", "a", "\\v{Z}", "\\v{z}",
                        "E", "e", "", "\\'{z}", "\\v{C}", "\\c{s}", "<<", ">>", " ", " ",
                        " ", "|", "+", "\\'{A}", "\\^{A}", "\\v{E}", "\\c{S}", "+", "|", "+",
                        "+", "\\.{Z}", "\\.{z}", "+", "+", "+", "+", "+", "-", "+",
                        "\\u{A}", "\\u{a}", "+", "+", "+", "+", "+", "-", "+", "o",
			"d", "D", "\\v{D}", "\\\"{E}", "\\v{d}", "\\v{N}", "\\'{I}", "\\^{I}", "\\v{e}", "+",
                        "+", " ", " ", "\\c{T}", "\\r{U}", " ", "\\'{O}", "\\ss", "\\^{O}", "\\'{N}", 
                        "\\'{n}", "\\v{n}", "\\v{S}", "\\v{s}", "\\'{R}", "\\'{U}", "\\'{r}", "\\:{U}", "\\'{y}", "\\'{Y}",
                        "\\c{t}", "\\'{}", "$\\overline{}", "\\:{}", ",", "\\v{}", "\\u{}", "\\S", "$\\div$", "\\c{}", 
                        "$\\overline{}$", "\\\"{}", "\\.{}", "\\:{u}", "\\v{R}", "\\v{r}", " ", ""};

   
  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) { if (fwrite(&c, sizeof(c), 1, out) != 1) return 0; }
    else {
      if (fwrite(tab_lat2tex[c-128], sizeof(c), strlen(tab_lat2tex[c-128]), out) 
          != strlen(tab_lat2tex[c-128])) return 0;
    }
  }

  return 1;
}


int kam2iso(void)
{ unsigned char c, c_out;
  int pom_cc;
  TABLE tab_kam2iso={200, 252, 233, 239, 228, 207, 171, 232, 236, 204,
                     197, 205, 181, 229, 196, 193, 201, 190, 174, 244,
		     246, 211, 249, 218, 253, 214, 220, 169, 165, 221,
                     216, 187, 225, 237, 243, 250, 242, 210, 217, 212,
		     185, 248, 224, 192, 92, 167, 60, 62, 128, 128,
		     128, 124, 43, 43, 43, 43, 43, 43, 43, 43,
		     43, 43, 43, 43, 43, 43, 43, 43, 45, 43,
		     43, 43, 43, 43, 43, 43, 43, 45, 43, 43, 
		     43, 43, 43, 43, 43, 43, 43, 43, 43, 43,
		     43, 128, 32, 32, 32, 32, 97, 98, 71, 112,
		     83, 115, 109, 116, 70, 84, 79, 100, 111, 48,
		     128, 128, 61, 43, 62, 60, 128, 128, 247, 126,
		     32, 255, 255, 32, 32, 32, 32, 128};

  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) c_out=c;
    else c_out=tab_kam2iso[c-128];
    if (fwrite(&c_out, sizeof(c_out), 1, out) != 1) return 0;
  }

  return 1;
}


int kam2win(void)
{ unsigned char c, c_out;
  int pom_cc;
  TABLE tab_kam2win={200, 252, 233, 239, 228, 207, 141, 232, 236, 204,
                     197, 205, 190, 229, 196, 193, 201, 158, 142, 244,
                     246, 211, 249, 218, 253, 214, 220, 138, 188, 221,
                     216, 157, 225, 237, 243, 250, 242, 210, 217, 212,
                     154, 248, 224, 192, 172, 167, 171, 187, 128, 128, 
                     128, 124, 43, 43, 43, 43, 43, 43, 43, 43,
                     43, 43, 43, 43, 43, 43, 43, 43, 45, 43,
                     43, 43, 43, 43, 43, 43, 43, 45, 43, 43, 
                     43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 
                     43, 128, 32, 32, 32, 32, 97, 98, 71, 112,
                     83, 115, 109, 116, 70, 84, 79, 100, 111, 48,
                     128, 128, 61, 177, 62, 60, 128, 128, 247, 126,
                     128, 149, 255, 32, 32, 32, 32, 128};

  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) c_out=c;
    else c_out=tab_kam2win[c-128];
    if (fwrite(&c_out, sizeof(c_out), 1, out) != 1) return 0;
  }

  return 1;
}

int kam2lat(void)
{ unsigned char c, c_out;
  int pom_cc;
  TABLE tab_kam2lat={172, 129, 130, 212, 132, 210, 155, 159, 216, 183,
                     145, 214, 150, 146, 142, 181, 144, 167, 166, 147, 
		     148, 224, 133, 233, 253, 153, 154, 230, 149, 237, 
		     252, 156, 160, 161, 162, 163, 229, 213, 222, 226, 
		     231, 253, 234, 232, 32, 245, 174, 175, 176, 177,
		     178, 179, 180, 185, 185, 187, 187, 185, 186, 187,
		     188, 188, 188, 191, 192, 193, 194, 195, 196, 197,
		     204, 204, 200, 201, 202, 203, 204, 205, 206, 202,
		     202, 203, 203, 200, 200, 201, 201, 206, 206, 217, 
		     218, 219, 220, 32, 32, 223, 97, 98, 71, 112,
		     83, 115, 109, 116, 70, 84, 79, 100, 111, 48,
		     32, 32, 61, 43, 62, 60, 32, 255, 246, 32,
		     250, 249, 250, 32, 32, 32, 254, 255};

  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) c_out=c;
    else c_out=tab_kam2lat[c-128];
    if (fwrite(&c_out, sizeof(c_out), 1, out) != 1) return 0;
  }

  return 1;
}

int kam2ascii(void)
{ unsigned char c, c_out;
  int pom_cc;
  TABLE tab_kam2ascii={67, 117, 101, 100, 97, 68, 84, 99, 101, 69,
                       76, 73, 108, 108, 65, 65, 69, 122, 90, 111,
                       111, 79, 117, 85, 121, 79, 85, 83, 76, 89,
                       82, 116, 97, 105, 111, 117, 110, 78, 85, 79,
                       115, 114, 114, 82, 32, 32, 60, 62, 32, 32,
                       32, 124, 43, 43, 43, 43, 43, 43, 124, 43,
                       43, 43, 43, 43, 43, 43, 43, 43, 45, 43,
                       43, 43, 43, 43, 43, 43, 43, 45, 43, 43,
                       43, 43, 43, 43, 43, 43, 43, 43, 43, 43,
                       43, 32, 32, 32, 32, 32, 97, 98, 71, 112,
		       83, 115, 109, 116, 70, 84, 79, 100, 111, 48,
		       32, 32, 61, 43, 62, 60, 32, 128, 47, 32,
		       46, 46, 46, 32, 32, 32, 32, 128};
		    
  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) c_out=c;
    else c_out=tab_kam2ascii[c-128];
    if (fwrite(&c_out, sizeof(c_out), 1, out) != 1) return 0;
  }

  return 1;
}

int kam2post(void)
{ unsigned char c;
  int pom_cc;
  L_TABLE tab_kam2post={"C<", "u:", "e'", "d<", "a:", "D<", "T<", "c<", "e<", "E<",
                        "L'", "I'", "l<", "l'", "A:", "A'", "E'", "z<", "Z<", "o^",
                        "o:", "O'", "u*", "U'", "y'", "O:", "U:", "S<", "L<", "Y'", 
                        "R<", "t<", "a'", "i'", "o'", "u'", "n<", "N<", "U*", "O^",
                        "s<", "r<", "r'", "R'", "1/4", "[paragraf]", "<<", ">>", " ", " ",
                        " ", "|", "+", "+", "+", "+", "+", "+", "|", "+",
                        "+", "+", "+", "+", "+", "+", "+", "+", "-", "+",
                        "+", "+", "+", "+", "+", "+", "+", "-", "+", "+",
			"+", "+", "+", "+", "+", "+", "+", "+", "+", "+",
                        "+", " ", " ", " ", " ", " ", "[alfa]", "[beta]", "[Gama]", "[pi]", 
                        "[Sigma]", "[sigma]", "[mi]", "[tau]", "[Psi]", "[Theta]", "[Omega]", "[delta]", "[omega]", "[psi]",
                        "[nalezi]", "[prunik]", "[ekviv]", "+", ">=", "<=", "[integral]", "", "/", "[priblizne]", 
                        "[stupen]", " ", ".", "[odmocnina]", "[na n-tou]", "[na druhou]", " ", ""};

   
  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) { if (fwrite(&c, sizeof(c), 1, out) != 1) return 0; }
    else {
      if (fwrite(tab_kam2post[c-128], sizeof(c), strlen(tab_kam2post[c-128]), out) 
          != strlen(tab_kam2post[c-128])) return 0;
    }
  }
  return 1;
}

int kam2pref(void)
{ unsigned char c;
  int pom_cc;
  L_TABLE tab_kam2pref={">C", ":u", "'e", ">d", ":a", ">D", ">T", ">c", ">e", ">E",
                        "'L", "'I", ">l", "'l", ":A", "'A", "'E", ">z", ">Z", "^o",
                        ":o", "'O", "*u", "'U", "'y", ":O", ":U", ">S", ">L", "'Y", 
                        ">R", ">t", "'a", "'i", "'o", "'u", ">n", ">N", "*U", "^O",
                        ">s", ">r", "'r", "'R", "1/4", "[paragraf]", "<<", ">>", " ", " ",
                        " ", "|", "+", "+", "+", "+", "+", "+", "|", "+",
                        "+", "+", "+", "+", "+", "+", "+", "+", "-", "+",
                        "+", "+", "+", "+", "+", "+", "+", "-", "+", "+",
			"+", "+", "+", "+", "+", "+", "+", "+", "+", "+",
                        "+", " ", " ", " ", " ", " ", "[alfa]", "[beta]", "[Gama]", "[pi]", 
                        "[Sigma]", "[sigma]", "[mi]", "[tau]", "[Psi]", "[Theta]", "[Omega]", "[delta]", "[omega]", "[psi]",
                        "[nalezi]", "[prunik]", "[ekviv]", "+", ">=", "<=", "[integral]", "", "/", "[priblizne]", 
                        "[stupen]", " ", ".", "[odmocnina]", "[na n-tou]", "[na druhou]", " ", ""};

   
  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) { if (fwrite(&c, sizeof(c), 1, out) != 1) return 0; }
    else {
      if (fwrite(tab_kam2pref[c-128], sizeof(c), strlen(tab_kam2pref[c-128]), out) 
          != strlen(tab_kam2pref[c-128])) return 0;
    }
  }
  return 1;
}

int kam2tex(void)
{ unsigned char c;
  int pom_cc;
  L_TABLE tab_kam2tex={"\\v{C}", "\\\"{u}", "\\'{e}", "\\v{d}", "\\\"{a}", "\\v{D}", "\\v{T}", "\\v{c}", "\\v{e}", "\\v{E}",
                        "\\'{L}", "\\'{I}", "\\v{l}", "\\'{l}", "\\\"{A}", "\\'{A}", "\\'{E}", "\\v{z}", "\\v{Z}", "\\^{o}",
                        "\\\"{o}", "\\'{O}", "\\r{u}", "\\'{U}", "\\'{y}", "\\\"{O}", "\\\"{U}", "\\v{S}", "\\v{L}", "\\'{Y}", 
                        "\\v{R}", "\\v{t}", "\\'{a}", "\\'\\i", "\\'{o}", "\\'{u}", "\\v{n}", "\\v{N}", "\\r{U}", "\\^{O}",
                        "\\v{s}", "\\v{r}", "\\'{r}", "\\'{R}", "1/4", "\\S", "<<", ">>", " ", " ",
                        " ", "|", "+", "+", "+", "+", "+", "+", "|", "+",
                        "+", "+", "+", "+", "+", "+", "+", "+", "-", "+",
                        "+", "+", "+", "+", "+", "+", "+", "-", "+", "+",
			"+", "+", "+", "+", "+", "+", "+", "+", "+", "+",
                        "+", " ", " ", " ", " ", " ", "$\\alpha$", "$\\beta$", "$\\Gamma$", "$\\pi$", 
                        "$\\Sigma$", "$\\sigma$", "$\\mu$", "$\\tau$", "$\\Psi$", "$\\Theta$", "$\\Omega$", "$\\delta$", "$\\omega$", "$\\psi$",
                        "$\\in$", "$\\cap$", "$\\equiv$", "$\\pm$", "$\\geq$", "$\\leq$", "$\\int$", "", "$\\div$", "$\\approx$", 
                        "$\\circ$", "$\\bullet$", "$\\cdot$", "$\\sqrt{}$", "$^n$", "$^2$", " ", ""};

   
  while (read_char(&pom_cc)) {
    c=pom_cc;
    if (isascii(c)) { if (fwrite(&c, sizeof(c), 1, out) != 1) return 0; }
    else {
      if (fwrite(tab_kam2tex[c-128], sizeof(c), strlen(tab_kam2tex[c-128]), out) 
          != strlen(tab_kam2tex[c-128])) return 0;
    }
  }
  return 1;
}

int recode(FILE *sour_f, FILE *dest_f, int sour_c, int dest_c, int line_e)
{ in=sour_f;
  out=dest_f;
  l=line_e;

  if ((sour_c == dest_c) || (sour_c == CZ_ASCII)) { /* jsou-li kodovani stejna */
    if (cod2cod() == 0) return 1;
    else return 0;
  }
  
  if (sour_c == CZ_ISO) 
    switch (dest_c) {
    case CZ_WIN: if (iso2win() == 0) return 1;
            else return 0;
    case CZ_LAT: if (iso2lat() == 0) return 1;
            else return 0;
    case CZ_KAM: if (iso2kam() == 0) return 1;
            else return 0;
    case CZ_ASCII: if (iso2ascii() == 0) return 1;
            else return 0;
    case CZ_POST: if (iso2post() == 0) return 1;
            else return 0;
    case CZ_PREF: if (iso2pref() == 0) return 1;
            else return 0;
    case CZ_TEX: if (iso2tex() == 0) return 1;
            else return 0;
    default: return -1;
    }
  else
  if (sour_c == CZ_WIN)
    switch (dest_c) {
    case CZ_ISO: if (win2iso() == 0) return 1;
            else return 0;
    case CZ_LAT: if (win2lat() == 0) return 1;
            else return 0;
    case CZ_KAM: if (win2kam() == 0) return 1;
            else return 0;
    case CZ_ASCII: if (win2ascii() == 0) return 1;
            else return 0;
    case CZ_POST: if (win2post() == 0) return 1;
            else return 0;
    case CZ_PREF: if (win2pref() == 0) return 1;
            else return 0;
    case CZ_TEX: if (win2tex() == 0) return 1;
            else return 0;	    	    
    default: return -1;
    }
   else
   if (sour_c == CZ_LAT)
     switch (dest_c) {
     case CZ_ISO: if (lat2iso() == 0) return 1;
             else return 0;
     case CZ_WIN: if (lat2win() == 0) return 1;
             else return 0;	     
     case CZ_KAM: if (lat2kam() == 0) return 1;
             else return 0;
     case CZ_ASCII: if (lat2ascii() == 0) return 1;
             else return 0;
     case CZ_POST: if (lat2post() == 0) return 1;
             else return 0;
     case CZ_PREF: if (lat2pref() == 0) return 1;
             else return 0;
     case CZ_TEX: if (lat2tex() == 0) return 1;
             else return 0;	 
     default: return -1;
     }
   else
   if (sour_c == CZ_KAM)
     switch (dest_c) {
     case CZ_ISO: if (kam2iso() == 0) return 1;
             else return 0;
     case CZ_WIN: if (kam2win() == 0) return 1;
             else return 0;
     case CZ_LAT: if (kam2lat() == 0) return 1; 
             return 0;
     case CZ_ASCII: if (kam2ascii() == 0) return 1;
             else return 0;
     case CZ_POST: if (kam2post() == 0) return 1;
             else return 0;
     case CZ_PREF: if (kam2pref() == 0) return 1;
             else return 0;
     case CZ_TEX: if (kam2tex() == 0) return 1;
             else return 0;	
     default: return -1;
     }
   else
     return -1; 
} 



